<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content class">
                   <div class="content-data">











<ol class="breadcrumb">
  <li>Classes</li>
  <li>OperationsDataSource</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/app/dashboard/operation-list/operation-list.component.ts</code>
        </p>


            <p class="comment">
                <h3>Extends</h3>
            </p>
            <p class="comment">
                    <code>DataSource</code>
            </p>



            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#connect">connect</a>
                            </li>
                            <li>
                                <a href="#disconnect">disconnect</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(operations: <a href="../classes/Operation.html">BehaviorSubject<Operation[]></a>, sort: MatSort)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="60" class="link-to-prism">src/app/dashboard/operation-list/operation-list.component.ts:60</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>operations</td>
                                                  
                                                        <td>
                                                                    <code><a href="../classes/Operation.html" target="_self" >BehaviorSubject&lt;Operation[]&gt;</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>sort</td>
                                                  
                                                        <td>
                                                                    <code>MatSort</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>


            <section>
    
        <h3 id="methods">
            Methods
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="connect"></a>
                        <span class="name">
                            <b>
                            connect
                            </b>
                            <a href="#connect"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>connect()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="66" class="link-to-prism">src/app/dashboard/operation-list/operation-list.component.ts:66</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="../classes/Operation.html" target="_self" >Observable&lt;Operation[]&gt;</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="disconnect"></a>
                        <span class="name">
                            <b>
                            disconnect
                            </b>
                            <a href="#disconnect"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>disconnect()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="74" class="link-to-prism">src/app/dashboard/operation-list/operation-list.component.ts:74</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>






    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Component, OnInit, ViewChild } from &quot;@angular/core&quot;;
import { Router } from &quot;@angular/router&quot;;
import { DataSource } from &quot;@angular/cdk/collections&quot;;
import { Observable } from &quot;rxjs/Observable&quot;;
import { BehaviorSubject } from &quot;rxjs/BehaviorSubject&quot;;
import { MatSort } from &quot;@angular/material&quot;;
import &quot;rxjs/add/operator/map&quot;;
import &quot;rxjs/add/observable/merge&quot;;
import { map, merge } from &quot;rxjs/operators&quot;;
import { Operation } from &quot;../../operation/model/operation&quot;;
import { OperationService } from &quot;../../operation/service/operation.service&quot;;
import { sortOnProperty } from &quot;../../core/util/table-utils&quot;;
import { AuthorizationService } from &quot;../../core/service/http/authorization.service&quot;;
import { GeneratedVotingMaterialService } from &quot;../../operation/service/generated-voting-material.service&quot;;
import { FileService } from &quot;../../core/service/file-service/file-service&quot;;
import { HttpParameters } from &#x27;../../core/service/http/http.parameters.service&#x27;;

@Component({
  selector: &#x27;operation-list&#x27;,
  templateUrl: &#x27;./operation-list.component.html&#x27;,
  styleUrls: [&#x27;./operation-list.component.scss&#x27;]
})
export class OperationListComponent implements OnInit {
  allOperations &#x3D; new BehaviorSubject&lt;Operation[]&gt;([]);
  @ViewChild(MatSort) sort: MatSort;
  dataSource;
  displayedColumns;

  constructor(private operationService: OperationService,
              private authorizationService: AuthorizationService,
              private fileService: FileService,
              private httpParams: HttpParameters,
              private generatedVotingMaterialService: GeneratedVotingMaterialService,
              private router: Router) {
  }

  ngOnInit(): void {
    this.displayedColumns &#x3D; this.authorizationService.hasAtLeastOneRole([&quot;ROLE_PRINTER&quot;]) ?
      [&#x27;date&#x27;, &#x27;shortLabel&#x27;, &#x27;longLabel&#x27;, &#x27;printerArchiveInfo&#x27;, &#x27;printerArchiveDownload&#x27;]
      : [&#x27;date&#x27;, &#x27;shortLabel&#x27;, &#x27;longLabel&#x27;, &#x27;management&#x27;];

    this.refreshOperations();
    this.dataSource &#x3D; new OperationsDataSource(this.allOperations, this.sort);
  }

  refreshOperations() {
    this.operationService.findAll().subscribe((operations &#x3D;&gt; this.allOperations.next(operations)));
  }

  public management(id: number): void {
    this.router.navigate([&quot;operations&quot;, id]);
  }

  public getDownloadLink(token: string) {

    return &#x60;${this.httpParams.apiBaseURL}/download-with-token/${token}&#x60;;
  }
}

class OperationsDataSource extends DataSource&lt;any&gt; {

  constructor(private operations: BehaviorSubject&lt;Operation[]&gt;, private sort: MatSort) {
    super();
  }

  connect(): Observable&lt;Operation[]&gt; {
    return this.operations.pipe(
      merge(this.sort.sortChange),
      map(() &#x3D;&gt; sortOnProperty(this.operations.getValue(), this.sort.active, this.sort.direction))
    );

  }

  disconnect() {
  }
}
</code></pre>
    </div>
</div>







                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'class';
            var COMPODOC_CURRENT_PAGE_URL = 'OperationsDataSource.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
